-----------------------------------------------------------------------------
-- |
-- Module      :  
-- Copyright   :  (c) Marcel Fourné 2009
-- License     :  BSD3
-- Maintainer  :  Marcel Fourné (hecc@bitrot.dyndns.org
--
-- computing ECDH-values as an example
--
-----------------------------------------------------------------------------

import Codec.Encryption.ECC.Base

ecdh :: (ECP a) => EC -> a -> Integer -> t -> Integer
ecdh c a kprivA kprivB = let kpubA = pmul a kprivA c
                             kpubB = pmul a kprivA c
                             ergA = pmul kpubB kprivA c
                         in getx ergA c